<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: &lt;SDImageCache&gt; Protocol Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Instance Methods</a> &#124;
<a href="protocol_s_d_image_cache-p-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">&lt;SDImageCache&gt; Protocol Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#import &lt;<a class="el" href="_s_d_image_cache_define_8h_source.html">SDImageCacheDefine.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for &lt;SDImageCache&gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="protocol_s_d_image_cache-p.png" usemap="#_3CSDImageCache_3E_map" alt=""/>
  <map id="_3CSDImageCache_3E_map" name="_3CSDImageCache_3E_map">
<area href="interface_s_d_image_caches_manager.html" alt="SDImageCachesManager" shape="rect" coords="0,112,156,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Instance Methods</h2></td></tr>
<tr class="memitem:af4f5e3d6330b9cded30bfb49a5f04499"><td class="memItemLeft" align="right" valign="top">(nullable id&lt; <a class="el" href="protocol_s_d_web_image_operation-p.html">SDWebImageOperation</a> &gt;)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_cache-p.html#af4f5e3d6330b9cded30bfb49a5f04499">queryImageForKey:options:context:completion:</a></td></tr>
<tr class="separator:af4f5e3d6330b9cded30bfb49a5f04499"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18d2180059fd141089b7b3e88b4ab423"><td class="memItemLeft" align="right" valign="top">(void)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_cache-p.html#a18d2180059fd141089b7b3e88b4ab423">storeImage:imageData:forKey:cacheType:completion:</a></td></tr>
<tr class="separator:a18d2180059fd141089b7b3e88b4ab423"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1464e0ed987c39d8c3b91c71d693018a"><td class="memItemLeft" align="right" valign="top">(void)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_cache-p.html#a1464e0ed987c39d8c3b91c71d693018a">removeImageForKey:cacheType:completion:</a></td></tr>
<tr class="separator:a1464e0ed987c39d8c3b91c71d693018a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af2bcbabb575f0f7819e0bc6d24763bc9"><td class="memItemLeft" align="right" valign="top">(void)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_cache-p.html#af2bcbabb575f0f7819e0bc6d24763bc9">containsImageForKey:cacheType:completion:</a></td></tr>
<tr class="separator:af2bcbabb575f0f7819e0bc6d24763bc9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad55adbb272467ce4dab876ead3a07e64"><td class="memItemLeft" align="right" valign="top">(void)&#160;</td><td class="memItemRight" valign="bottom">- <a class="el" href="protocol_s_d_image_cache-p.html#ad55adbb272467ce4dab876ead3a07e64">clearWithCacheType:completion:</a></td></tr>
<tr class="separator:ad55adbb272467ce4dab876ead3a07e64"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This is the image cache protocol to provide custom image cache for <code><a class="el" href="interface_s_d_web_image_manager.html">SDWebImageManager</a></code>. Though the best practice to custom image cache, is to write your own class which conform <code><a class="el" href="interface_s_d_memory_cache.html">SDMemoryCache</a></code> or <code><a class="el" href="interface_s_d_disk_cache.html">SDDiskCache</a></code> protocol for <code><a class="el" href="interface_s_d_image_cache.html">SDImageCache</a></code> class (See more on <code><a class="el" href="interface_s_d_image_cache_config.html#afeb75686cdea6e4c027f87749e95c090">SDImageCacheConfig.memoryCacheClass</a> &amp; <a class="el" href="interface_s_d_image_cache_config.html#af93f6ebb9accfba450d1012902e0c4a0">SDImageCacheConfig.diskCacheClass</a></code>). However, if your own cache implementation contains more advanced feature beyond <code><a class="el" href="interface_s_d_image_cache.html">SDImageCache</a></code> itself, you can consider to provide this instead. For example, you can even use a cache manager like <code><a class="el" href="interface_s_d_image_caches_manager.html">SDImageCachesManager</a></code> to register multiple caches. </p>
</div><h2 class="groupheader">Method Documentation</h2>
<a id="ad55adbb272467ce4dab876ead3a07e64"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad55adbb272467ce4dab876ead3a07e64">&#9670;&nbsp;</a></span>clearWithCacheType:completion:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (void) clearWithCacheType: </td>
          <td></td>
          <td class="paramtype">(SDImageCacheType)&#160;</td>
          <td class="paramname"><em>cacheType</em></td>
        </tr>
        <tr>
          <td class="paramkey">completion:</td>
          <td></td>
          <td class="paramtype">(nullable SDWebImageNoParamsBlock)&#160;</td>
          <td class="paramname"><em>completionBlock</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Clear all the cached images for image cache. If cache type is memory only, completion is called synchronously, else aynchronously.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">cacheType</td><td>The image clear op cache type </td></tr>
    <tr><td class="paramname">completionBlock</td><td>A block executed after the operation is finished </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af2bcbabb575f0f7819e0bc6d24763bc9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2bcbabb575f0f7819e0bc6d24763bc9">&#9670;&nbsp;</a></span>containsImageForKey:cacheType:completion:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (void) containsImageForKey: </td>
          <td></td>
          <td class="paramtype">(nullable NSString *)&#160;</td>
          <td class="paramname"><em>key</em></td>
        </tr>
        <tr>
          <td class="paramkey">cacheType:</td>
          <td></td>
          <td class="paramtype">(SDImageCacheType)&#160;</td>
          <td class="paramname"><em>cacheType</em></td>
        </tr>
        <tr>
          <td class="paramkey">completion:</td>
          <td></td>
          <td class="paramtype">(nullable SDImageCacheContainsCompletionBlock)&#160;</td>
          <td class="paramname"><em>completionBlock</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Check if image cache contains the image for the given key (does not load the image). If image is cached in memory, completion is called synchronously, else aynchronously.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The image cache key </td></tr>
    <tr><td class="paramname">cacheType</td><td>The image contains op cache type </td></tr>
    <tr><td class="paramname">completionBlock</td><td>A block executed after the operation is finished. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af4f5e3d6330b9cded30bfb49a5f04499"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4f5e3d6330b9cded30bfb49a5f04499">&#9670;&nbsp;</a></span>queryImageForKey:options:context:completion:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (nullable id&lt;<a class="el" href="protocol_s_d_web_image_operation-p.html">SDWebImageOperation</a>&gt;) queryImageForKey: </td>
          <td></td>
          <td class="paramtype">(nullable NSString *)&#160;</td>
          <td class="paramname"><em>key</em></td>
        </tr>
        <tr>
          <td class="paramkey">options:</td>
          <td></td>
          <td class="paramtype">(SDWebImageOptions)&#160;</td>
          <td class="paramname"><em>options</em></td>
        </tr>
        <tr>
          <td class="paramkey">context:</td>
          <td></td>
          <td class="paramtype">(nullable SDWebImageContext *)&#160;</td>
          <td class="paramname"><em>context</em></td>
        </tr>
        <tr>
          <td class="paramkey">completion:</td>
          <td></td>
          <td class="paramtype">(nullable SDImageCacheQueryCompletionBlock)&#160;</td>
          <td class="paramname"><em>completionBlock</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Query the cached image from image cache for given key. The operation can be used to cancel the query. If image is cached in memory, completion is called synchronously, else aynchronously and depends on the options arg (See <code>SDWebImageQueryDiskSync</code>)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The image cache key </td></tr>
    <tr><td class="paramname">options</td><td>A mask to specify options to use for this query </td></tr>
    <tr><td class="paramname">context</td><td>A context contains different options to perform specify changes or processes, see <code>SDWebImageContextOption</code>. This hold the extra objects which <code>options</code> enum can not hold. </td></tr>
    <tr><td class="paramname">completionBlock</td><td>The completion block. Will not get called if the operation is cancelled </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The operation for this query </dd></dl>

</div>
</div>
<a id="a1464e0ed987c39d8c3b91c71d693018a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1464e0ed987c39d8c3b91c71d693018a">&#9670;&nbsp;</a></span>removeImageForKey:cacheType:completion:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (void) removeImageForKey: </td>
          <td></td>
          <td class="paramtype">(nullable NSString *)&#160;</td>
          <td class="paramname"><em>key</em></td>
        </tr>
        <tr>
          <td class="paramkey">cacheType:</td>
          <td></td>
          <td class="paramtype">(SDImageCacheType)&#160;</td>
          <td class="paramname"><em>cacheType</em></td>
        </tr>
        <tr>
          <td class="paramkey">completion:</td>
          <td></td>
          <td class="paramtype">(nullable SDWebImageNoParamsBlock)&#160;</td>
          <td class="paramname"><em>completionBlock</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Remove the image from image cache for the given key. If cache type is memory only, completion is called synchronously, else aynchronously.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The image cache key </td></tr>
    <tr><td class="paramname">cacheType</td><td>The image remove op cache type </td></tr>
    <tr><td class="paramname">completionBlock</td><td>A block executed after the operation is finished </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a18d2180059fd141089b7b3e88b4ab423"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a18d2180059fd141089b7b3e88b4ab423">&#9670;&nbsp;</a></span>storeImage:imageData:forKey:cacheType:completion:()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">- (void) storeImage: </td>
          <td></td>
          <td class="paramtype">(nullable UIImage *)&#160;</td>
          <td class="paramname"><em>image</em></td>
        </tr>
        <tr>
          <td class="paramkey">imageData:</td>
          <td></td>
          <td class="paramtype">(nullable NSData *)&#160;</td>
          <td class="paramname"><em>imageData</em></td>
        </tr>
        <tr>
          <td class="paramkey">forKey:</td>
          <td></td>
          <td class="paramtype">(nullable NSString *)&#160;</td>
          <td class="paramname"><em>key</em></td>
        </tr>
        <tr>
          <td class="paramkey">cacheType:</td>
          <td></td>
          <td class="paramtype">(SDImageCacheType)&#160;</td>
          <td class="paramname"><em>cacheType</em></td>
        </tr>
        <tr>
          <td class="paramkey">completion:</td>
          <td></td>
          <td class="paramtype">(nullable SDWebImageNoParamsBlock)&#160;</td>
          <td class="paramname"><em>completionBlock</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">required</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Store the image into image cache for the given key. If cache type is memory only, completion is called synchronously, else aynchronously.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">image</td><td>The image to store </td></tr>
    <tr><td class="paramname">imageData</td><td>The image data to be used for disk storage </td></tr>
    <tr><td class="paramname">key</td><td>The image cache key </td></tr>
    <tr><td class="paramname">cacheType</td><td>The image store op cache type </td></tr>
    <tr><td class="paramname">completionBlock</td><td>A block executed after the operation is finished </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this protocol was generated from the following file:<ul>
<li><a class="el" href="_s_d_image_cache_define_8h_source.html">SDImageCacheDefine.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
